unit uNim3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mTSpielmanager, ExtCtrls;

type
  TForm1 = class(TForm)
    eSpieler1: TEdit; lSpieler1: TLabel;
    eSpieler2: TEdit; lSpieler2: TLabel;
    lBotschaft: TLabel; bNeuesSpiel: TButton; bNehmen: TButton;
    gbHaufen1: TGroupBox; Shape11: TShape; Shape12: TShape; Shape13: TShape;
    gbHaufen2: TGroupBox; Shape21: TShape; Shape22: TShape; Shape23: TShape;
    Shape24: TShape;
    gbHaufen3: TGroupBox; Shape31: TShape; Shape32: TShape; Shape33: TShape;
    Shape34: TShape; Shape35: TShape;
    lh1: TLabel; lh2: TLabel; lh3: TLabel;
    lm1: TLabel; lm2: TLabel; lm3: TLabel;
    lha: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bNeuesSpielClick(Sender: TObject);
    procedure bNehmenClick(Sender: TObject);
    procedure Shape11MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    Spielmanager : TSpielmanager;
    Markieren_freigegeben : boolean;   // drfen Hlzchen markiert werden
    markiert : array[1..3] of integer; // Zhler fr Markierungen in Haufen i
    procedure updateGUI;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  SpielManager := TSpielmanager.Create;
  // Initialisierungen
  Markieren_freigegeben := false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Spielmanager.Free;
end;

procedure TForm1.updateGUI;
begin
  lBotschaft.Caption := Spielmanager.GetBotschaft;
  // DEBUG
  lh1.Caption := IntToStr(Spielmanager.GetHoelzchenZahl(1));
  lh2.Caption := IntToStr(Spielmanager.GetHoelzchenZahl(2));
  lh3.Caption := IntToStr(Spielmanager.GetHoelzchenZahl(3));
  lm1.Caption := IntToStr(markiert[1]);
  lm2.Caption := IntToStr(markiert[2]);
  lm3.Caption := IntToStr(markiert[3]);

end;

procedure TForm1.bNeuesSpielClick(Sender: TObject);
var
  name1,name2 : string;
  i           : integer;
begin
  name1 := eSpieler1.text; name2 := eSpieler2.text;
  if (length(name1)>0) and (length(name2)>0)
  then
  begin
    Spielmanager.neuesSpiel(name1,name2);
    updateGUI;
    for i := 0 to ComponentCount-1 do
    if Components[i] is TShape
    then
    begin
      TShape(Components[i]).Visible := true;
      TShape(Components[i]).Brush.color := clWhite;
      TShape(Components[i]).Tag := 0;
    end;
    markiert[1] := 0; markiert[2] := 0; markiert[3] := 0;
    Markieren_freigegeben := true;
  end;
end;

procedure TForm1.bNehmenClick(Sender: TObject);
var
  ha,a,i : integer; // ha : aktuelle Haufennummer, a : Markierungszhler
  S_akt  : TShape;  // aktuelles Shape
begin
  if markiert[1]+markiert[2]+markiert[3] > 0 // berhaupt etwas markiert?
  then
  begin
    a := 0;
    for i := 0 to ComponentCount-1 do
    if Components[i].Tag = 1
    then
    begin
      S_akt := TShape(Components[i]);
      S_akt.Visible := false; // Shape auf unsichtbar
      ha := StrToInt(copy(S_akt.name,Length(S_akt.name)-1,1));
      Inc(a); // Anzahl erhhen
      Components[i].Tag := 0; // Markierung zurcksetzen
    end;
    Spielmanager.verarbeiteEingabe(ha,a);
    markiert[ha] := 0; // Markierungszhler zurcksetzen
    updateGUI;
  end;
end;

procedure TForm1.Shape11MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  S_akt    : TShape;  // Zeiger auf aktuelles Shape
  ha,hb,hc : integer; // Haufennummern, ha ist aktueller Haufen
begin
  S_akt := TShape(Sender); // S_akt greift auf aufrufendes Shape zu
  // Haufennummer des aktuellen Haufens ermitteln
  ha := StrToInt(copy(S_akt.name,Length(S_akt.name)-1,1));
  // DEBUG
  lha.Caption := copy(S_akt.name,Length(S_akt.name)-1,1);

  // Nummern der Rest-Haufen bestimmen
  if ha = 1 then begin hb := 2; hc := 3; end;
  if ha = 2 then begin hb := 1; hc := 3; end;
  if ha = 3 then begin hb := 1; hc := 2; end;

  if Markieren_freigegeben and
     (markiert[hb] = 0) and // auf beiden anderen Haufen ist nichts markiert
     (markiert[hc] = 0)
  then
  begin
    if S_akt.Tag = 0               // bisher nicht markiert
    then
    begin
      S_akt.Brush.Color := clRed;  // rot frben
      S_akt.Tag := 1;              // Markierung setzen
      inc(markiert[ha]);
    end
    else
    begin
      S_akt.Brush.Color := clWhite; // wieder wei frben
      S_akt.Tag := 0;               // Markierung zurcksetzen
      dec(markiert[ha]);
    end;
  end;
  // DEBUG
  lm1.Caption := IntToStr(markiert[1]);
  lm2.Caption := IntToStr(markiert[2]);
  lm3.Caption := IntToStr(markiert[3]);
end;

end.
